unit About;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, Buttons, Rollups, StdCtrls, ExtCtrls;

type
  TfrmRollupAbout = class(TRollupForm)
    btnClose: TSpeedButton;
    btnRollDown: TSpeedButton;
    btnRollUp: TSpeedButton;
    btnMenu: TSpeedButton;
    PopupMenu1: TPopupMenu;
    SomeItem1: TMenuItem;
    SomeOtherItem1: TMenuItem;
    Label1: TLabel;
    Label3: TLabel;
    cmdClose: TButton;
    Image1: TImage;
    Label2: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnRollDownClick(Sender: TObject);
    procedure btnRollUpClick(Sender: TObject);
    procedure btnMenuClick(Sender: TObject);
    procedure cmdCloseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRollupAbout: TfrmRollupAbout;

implementation

{$R *.DFM}

procedure TfrmRollupAbout.FormActivate(Sender: TObject);
begin
  RU_FormPaint (self, btnRollup, btnRollDown, btnClose);
end;

procedure TfrmRollupAbout.FormCreate(Sender: TObject);
begin
  RU_Init (self, btnRollUp, btnRollDown, btnClose, btnMenu);

  { Make the form appear as a title bar only }
  RU_RollUp (self, btnRollUp, btnRollDown, btnClose);
end;

procedure TfrmRollupAbout.FormDeactivate(Sender: TObject);
begin
  RU_FormDeactivate (self, btnRollUp, btnRollDown, btnClose);
end;

procedure TfrmRollupAbout.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  RU_FormMouseDown (self, x, y);
end;

procedure TfrmRollupAbout.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  RU_FormMouseMove (self, x, y);
end;

procedure TfrmRollupAbout.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  RU_FormMouseUp;
end;

procedure TfrmRollupAbout.FormPaint(Sender: TObject);
begin
  RU_FormPaint (self, btnRollUp, btnRollDown, btnClose);
end;

procedure TfrmRollupAbout.btnCloseClick(Sender: TObject);
begin
  close;
end;

procedure TfrmRollupAbout.btnRollDownClick(Sender: TObject);
begin
  RU_RollDown (self, btnRollUp, btnRollDown, btnClose);
end;

procedure TfrmRollupAbout.btnRollUpClick(Sender: TObject);
begin
  RU_RollUp (self, btnRollUp, btnRollDown, btnClose);
end;

procedure TfrmRollupAbout.btnMenuClick(Sender: TObject);
begin
  RU_ShowMenu (self, btnMenu, PopupMenu1);
end;

procedure TfrmRollupAbout.cmdCloseClick(Sender: TObject);
begin
  Close;
end;

end.
