unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ApOpenDlg, ApFolderDlg, ComCtrls, ApTableDlg, ApDatabaseDlg,
  ApPrintDlg, ApColorDlg, shlobj;

type
  TForm1 = class(TForm)
    dlg1: TApOpenDialog;
    Button1: TButton;
    tbl: TApOpenTableDialog;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    prndlg: TApPrintDialog;
    Label1: TLabel;
    e1: TEdit;
    Label2: TLabel;
    Memo1: TMemo;
    Button6: TButton;
    cdlg: TApColorDialog;
    folder: TApFolderDialog;
    dbdlg: TApDatabaseDialog;
    procedure Button1Click(Sender: TObject);
    procedure dlg1SelectionStyleChange(Sender: TObject; AStyle: TViewStyle);
    procedure Button2Click(Sender: TObject);
    procedure dlg1LastFolderGoto(Sender: TObject; var bAllow: Boolean);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure prndlgChangePrinter(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cd1Close(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure prndlgNumOfCopiesChange(Sender: TObject);
    procedure prndlgPrinterChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure cdlgCustomColorAdding(Sender: TObject; var AColor: TColor;
      var AllowedColor: Boolean);
    procedure cdlgCustomColorAdd(Sender: TObject; AColor: TColor);
    procedure folderSelectionChange(Sender: TObject);
    procedure prndlgPrinterSetupShowing(Sender: TObject;
      var AllowProceed: Boolean);
    procedure dlg1SelectionChange(Sender: TObject);
    procedure dlg1ShareViolation(Sender: TObject; var DlgResult: Integer;
      FileName: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
         
implementation

uses PrinterCstm, commdlg, FolderCstm;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
if dlg1.Execute then begin
e1.Text := ExtractFilePath(dlg1.FileName);
Memo1.Lines.Assign(dlg1.Files);
end;
end;

procedure TForm1.dlg1SelectionStyleChange(Sender: TObject;
  AStyle: TViewStyle);
begin
if (AStyle = vsReport) then ShowMessage('report');
if (AStyle = vsIcon) then ShowMessage('icon');
if (AStyle = vsSmallIcon) then ShowMessage('smallicon');
if (AStyle = vsList) then ShowMessage('list');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
if tbl.Execute then begin
  e1.Text := tbl.DatabaseName;
  Memo1.Lines.Assign(tbl.Tables);
end;
end;

procedure TForm1.dlg1LastFolderGoto(Sender: TObject; var bAllow: Boolean);
begin
ShowMessage('This event occurs under Millennium only');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if (folder.Execute) then e1.Text := folder.FolderName;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if dbdlg.Execute then
  begin
   e1.Text := dbdlg.DatabaseName;
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
prndlg.Execute;
end;

procedure TForm1.prndlgChangePrinter(Sender: TObject);
begin
 Form4.Label2.Caption := 'You just selected: '+prndlg.SelectedDevice;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
dlg1.CustDlgParams.BottomFormName := 'Form2';
end;

procedure TForm1.cd1Close(Sender: TObject);
begin
//d.Execute;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
cdlg.Execute
end;

procedure TForm1.prndlgNumOfCopiesChange(Sender: TObject);
begin
//  ShowMessage('Will be printed '+IntToStr(prndlg.SelectedCopies)+' copies');
end;

procedure TForm1.prndlgPrinterChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  ShowMessage('Current printer device:'+prndlg.SelectedDevice);
end;

procedure TForm1.cdlgCustomColorAdding(Sender: TObject; var AColor: TColor;
  var AllowedColor: Boolean);
begin
 AColor := clYellow;
end;

procedure TForm1.cdlgCustomColorAdd(Sender: TObject; AColor: TColor);
begin
ShowMessage('But yellow color is added. Change this color in OnCustomColorAdding event handler')
end;

procedure TForm1.folderSelectionChange(Sender: TObject);
begin
//ShowMessage('selected folder : '+folder.SelectedFolder);
form3.FileListBox1.Directory :=folder.SelectedFolder;
end;

procedure TForm1.prndlgPrinterSetupShowing(Sender: TObject;
  var AllowProceed: Boolean);
begin
if MessageDlg('Do you really want to set up printer settings?',mtConfirmation,mbOKCancel,0) <> mrOk then
  AllowProceed := false;
end;

procedure TForm1.dlg1SelectionChange(Sender: TObject);
begin
//ShowMessage('selection changed');
end;

procedure TForm1.dlg1ShareViolation(Sender: TObject;
  var DlgResult: Integer; FileName: String);
begin
ShowMessage('vio')
end;

end.
