unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, MsgSimulator, ShellAPI;

type
  TMainForm = class(TForm)
    Label1: TLabel;
    SimClickBut: TButton;
    BeepBut: TButton;
    MsgSimulator1: TMsgSimulator;
    SimKeyBut: TButton;
    Edit1: TEdit;
    Button1: TButton;
    RecordBut: TButton;
    StopBut: TButton;
    PlayBut: TButton;
    Memo1: TMemo;
    procedure BeepButClick(Sender: TObject);
    procedure SimClickButClick(Sender: TObject);
    procedure SimKeyButClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure RecordButClick(Sender: TObject);
    procedure PlayButClick(Sender: TObject);
    procedure StopButClick(Sender: TObject);
    procedure MsgSimulator1StopRecord(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.BeepButClick(Sender: TObject);
begin
   Beep;
end;

procedure TMainForm.SimClickButClick(Sender: TObject);
begin
   with MsgSimulator1 do begin
      Messages.Clear;
      Add_Window_Click(BeepBut.Handle, 5, 5);
      Play;
   end;
   SimClickBut.SetFocus;
end;

procedure TMainForm.SimKeyButClick(Sender: TObject);
begin
   with MsgSimulator1 do begin
      Messages.Clear;
      Add_ASCII_Keys('This is a Test!');
      Edit1.SetFocus;
      Play;
   end;
   SimKeyBut.SetFocus;
end;

procedure TMainForm.Button1Click(Sender: TObject);
var
   StartInfo   : TStartupInfo;
   ProcInfo    : TProcessInformation;
begin
   GetStartupInfo(StartInfo);
   Win32Check(CreateProcess(nil, 'notepad.exe', nil, nil, True, 0, nil, nil, StartInfo, ProcInfo));
   WaitForInputIdle(ProcInfo.hProcess, INFINITE);

   with MsgSimulator1 do begin
      Messages.Clear;
      Add_ASCII_Keys('This is a Test!'#13);
      Add_ASCII_Keys('Next I will simulate an "F5" keypress:'#13);
      Add_VirtualKey(0, VK_F5, 1, mmKeyDown);
      Add_VirtualKey(0, VK_F5, 1, mmKeyUp);
      Play;
   end;
end;

procedure TMainForm.RecordButClick(Sender: TObject);
begin
   MsgSimulator1.Record_Input;
   StopBut.Enabled := True;
end;

procedure TMainForm.PlayButClick(Sender: TObject);
begin
   MsgSimulator1.Play;
end;

procedure TMainForm.StopButClick(Sender: TObject);
begin
   MsgSimulator1.Stop_Record;
end;

procedure TMainForm.MsgSimulator1StopRecord(Sender: TObject);
var
   i  : integer;
   mi : TMessageItem;
   s  : string;
begin
   StopBut.Enabled := False;

   for i := 0 to MsgSimulator1.Messages.Count-1 do begin
      mi := MsgSimulator1.Messages[i];

      s := Format('Msg: %3d  X: %4d  Y: %4d  Key: %4.4x  Delay: %4d', [integer(mi.Msg), mi.PosX, mi.PosY, mi.VkKey, mi.Delay]);
      Memo1.Lines.Add(s);
   end;
end;

end.
