unit Rolltest;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, Buttons, Rollups, StdCtrls, ExtCtrls;

type
  TfrmRollupTest = class(TRollupForm)
    btnClose: TSpeedButton;
    btnRollDown: TSpeedButton;
    btnRollUp: TSpeedButton;
    btnMenu: TSpeedButton;
    PopupMenu1: TPopupMenu;
    mnuAlignBottomRight: TMenuItem;
    mnuClose: TMenuItem;
    btnNormalSize: TButton;
    btnMaximize: TButton;
    mnuAlignTopRight: TMenuItem;
    N1: TMenuItem;
    grpColors: TRadioGroup;
    btnNormalColor: TButton;
    btnMinimize: TButton;
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnRollDownClick(Sender: TObject);
    procedure btnRollUpClick(Sender: TObject);
    procedure btnMenuClick(Sender: TObject);
    procedure mnuCloseClick(Sender: TObject);
    procedure mnuAlignBottomRightClick(Sender: TObject);
    procedure mnuAlignTopRightClick(Sender: TObject);
    procedure grpColorsClick(Sender: TObject);
    procedure btnNormalColorClick(Sender: TObject);
    procedure btnNormalSizeClick(Sender: TObject);
    procedure btnMaximizeClick(Sender: TObject);
    procedure btnMinimizeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRollupTest: TfrmRollupTest;

implementation
  uses Main;

{$R *.DFM}

procedure TfrmRollupTest.FormActivate(Sender: TObject);
begin
  RU_FormPaint (self, btnRollup, btnRollDown, btnClose);
end;

procedure TfrmRollupTest.FormCreate(Sender: TObject);
begin
  RU_Init (self, btnRollUp, btnRollDown, btnClose, btnMenu);
  self.clientheight := 195;
end;

procedure TfrmRollupTest.FormDeactivate(Sender: TObject);
begin
  RU_FormDeactivate (self, btnRollUp, btnRollDown, btnClose);
end;

procedure TfrmRollupTest.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  RU_FormMouseDown (self, x, y);
end;

procedure TfrmRollupTest.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  RU_FormMouseMove (self, x, y);
end;

procedure TfrmRollupTest.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  RU_FormMouseUp;
end;

procedure TfrmRollupTest.FormPaint(Sender: TObject);
begin
  RU_FormPaint (self, btnRollUp, btnRollDown, btnClose);
end;

procedure TfrmRollupTest.btnCloseClick(Sender: TObject);
begin
  close;
end;

procedure TfrmRollupTest.btnRollDownClick(Sender: TObject);
begin
  RU_RollDown (self, btnRollUp, btnRollDown, btnClose);
end;

procedure TfrmRollupTest.btnRollUpClick(Sender: TObject);
begin
  RU_RollUp (self, btnRollUp, btnRollDown, btnClose);
end;

procedure TfrmRollupTest.btnMenuClick(Sender: TObject);
begin
  RU_ShowMenu (self, btnMenu, PopupMenu1);
end;

procedure TfrmRollupTest.mnuCloseClick(Sender: TObject);
begin
  close;
end;

procedure TfrmRollupTest.mnuAlignBottomRightClick(Sender: TObject);
begin
  { Move the form to the bottom right of the screen }
  self.left := screen.width - self.clientwidth - 2;
  self.top  := screen.height - self.clientheight - 2;
end;

procedure TfrmRollupTest.mnuAlignTopRightClick(Sender: TObject);
begin
  { Move the form to the top right of the screen }
  self.left := screen.width - self.clientwidth - 2;
  self.top  := 2;
end;

procedure TfrmRollupTest.grpColorsClick(Sender: TObject);
begin
  case grpColors.itemindex of
    0: frmMain.color := clRed;
    1: frmMain.color := clGreen;
    2: frmMain.color := clBlue;
    3: frmMain.color := clWhite;
    4: frmMain.color := clBlack;
  end;
end;

procedure TfrmRollupTest.btnNormalColorClick(Sender: TObject);
begin
  frmMain.color := clBtnFace;
end;

procedure TfrmRollupTest.btnNormalSizeClick(Sender: TObject);
begin
  frmMain.windowstate := wsNormal;
end;

procedure TfrmRollupTest.btnMaximizeClick(Sender: TObject);
begin
  frmMain.windowstate := wsMaximized;
end;

procedure TfrmRollupTest.btnMinimizeClick(Sender: TObject);
begin
  frmMain.windowstate := wsMinimized;
end;

end.
