program _Setup;
{$APPTYPE CONSOLE}
uses
  SysUtils,
  Classes,
  Windows,
  ShellApi,
  TLHelp32,
  PSApi,
  SetupStructs in 'SetupStructs.pas';

type TplShowMode = (smNormal,smMaximized,smMinimized,smHide);

type TVDMEnumTaskWOWEx = function(A: DWORD; B: Pointer; C: PChar): integer stdcall;
type TDWordArray = array[0..8191] of DWord;
     PDWordArray = ^TDWordArray;

const ShowWindowModes: array[TplShowMode] of Integer = (sw_Normal,sw_ShowMaximized,sw_ShowMinimized,sw_Hide);


var
  i,p: integer;
  TempDir: array[0..MAX_PATH] of Char;
  Params,RunFile,WaitFile,ExePath,TempPath: string;
  Stream: TFileStream;
  ID: longword;
  FileCount: longint;
  Files: array of TFileData;

function Enum16(dwThreadId: DWORD; hMod16: WORD; hTask16: WORD; pszModName: PChar; pszFileName: PChar; lpUserDefined: PDWORD): boolean stdcall;
var
  hProcess: THANDLE;
begin
  if Lowercase(ExtractFileName(StrPas(pszFileName))) = Lowercase(StrPas(Pointer(lpUserDefined))) then begin
    hProcess := OpenProcess(PROCESS_ALL_ACCESS,True,hMod16);
    if hProcess <> 0 then
      WaitForSingleObject(HProcess,INFINITE);
    CloseHandle(hProcess);
  end;
  Result := True;
end;

function WaitProcessByName(Name: string): THANDLE;
var
  osver: OSVERSIONINFO;
  hInstLib: THANDLE;
  hInstLib2: THANDLE;
  hSnapShot: THANDLE;
  procentry: PROCESSENTRY32;
  bFlag: BOOL;
  lpdwPIDs: PDWordArray;
  dwSize, dwSize2, dwIndex: DWORD;
  hMod: HMODULE;
  hProcess: THANDLE;
  szFileName: array [0..MAX_PATH] of char;
  lpfEnumProcesses: TEnumProcesses;
  lpfEnumProcessModules: TEnumProcessModules;
  lpfGetModuleFileNameEx: TGetModuleFileNameEx;
  lpfCreateToolhelp32Snapshot: TCreateToolhelp32Snapshot;
  lpfProcess32First: TProcess32First;
  lpfProcess32Next: TProcess32Next;
//  lpfVDMEnumTaskWOWEx: TVDMEnumTaskWOWEx;
begin
      Result := 0;

      // Check to see if were running under Windows95 or

      // Windows NT.

      osver.dwOSVersionInfoSize :=SizeOf(osver);
      if not GetVersionEx(osver) then
        Exit;

      // If Windows NT:

      if  osver.dwPlatformId = VER_PLATFORM_WIN32_NT then begin
         // Load library and get the procedures explicitly. We do
         // this so that we don't have to worry about modules using
         // this code failing to load under Windows 95, because
         // it can't resolve references to the PSAPI.DLL.
         hInstLib := LoadLibraryA('PSAPI.DLL');
         if hInstLib = 0 then
           Exit;
         hInstLib2 := LoadLibraryA('VDMDBG.DLL');

         if hInstLib2 = 0 then
           Exit;

         // Get procedure addresses.
         lpfEnumProcesses := GetProcAddress(hInstLib,'EnumProcesses');
         lpfEnumProcessModules := GetProcAddress(hInstLib,'EnumProcessModules');
         lpfGetModuleFileNameEx := GetProcAddress(hInstLib,'GetModuleFileNameExA');
//         lpfVDMEnumTaskWOWEx := GetProcAddress(hInstLib2,'VDMEnumTaskWOWEx');

         if (Integer(@lpfEnumProcesses) = 0) or (Integer(@lpfEnumProcessModules) = 0) or
            (Integer(@lpfGetModuleFileNameEx) = 0) {or (Integer(@lpfVDMEnumTaskWOWEx) = 0)} then begin
           FreeLibrary(hInstLib);
           FreeLibrary(hInstLib2);
           Exit;
         end;


         // Call the PSAPI function EnumProcesses to get all of the
         // ProcID's currently in the system.
         // NOTE: In the documentation, the third parameter of
         // EnumProcesses is named cbNeeded, which implies that you
         // can call the function once to find out how much space to
         // allocate for a buffer and again to fill the buffer.
         // This is not the case. The cbNeeded parameter returns
         // the number of PIDs returned, so if your buffer size is
         // zero cbNeeded returns zero.
         // NOTE: The "HeapAlloc" loop here ensures that we
         // actually allocate a buffer large enough for all the
         // PIDs in the system.

         dwSize2 := 256 * SizeOf(DWORD);
         lpdwPIDs := 0;
         repeat
           if lpdwPIDs <> Nil then begin
             HeapFree(GetProcessHeap(),0,lpdwPIDs);
             dwSize2 := dwSize2 * 2 ;
           end;
           lpdwPIDs := HeapAlloc(GetProcessHeap(),0,dwSize2);
           if lpdwPIDs = Nil then begin
             FreeLibrary( hInstLib ) ;
             FreeLibrary( hInstLib2 ) ;
             Exit;
           end;

           if not lpfEnumProcesses(Pointer(lpdwPIDs),dwSize2,dwSize) then begin
             HeapFree(GetProcessHeap(),0,lpdwPIDs);
             FreeLibrary( hInstLib ) ;
             FreeLibrary( hInstLib2 ) ;
             Exit;
           end;

         until(dwSize <> dwSize2);

         // How many ProcID's did we get?
         dwSize := dwSize div sizeof(DWORD);

         // Loop through each ProcID.
         dwIndex := 0;
         while dwIndex < dwSize do begin
           szFileName[0] := #0;

           // Open the process (if we can... security does not
           // permit every process in the system).
           hProcess := OpenProcess(PROCESS_QUERY_INFORMATION or PROCESS_VM_READ,FALSE,lpdwPIDs[dwIndex]);

            if hProcess <> 0 then begin
              // Here we call EnumProcessModules to get only the
              // first module in the process this is important,
              // because this will be the .EXE module for which we
              // will retrieve the full path name in a second.
              if lpfEnumProcessModules(hProcess,@hMod,sizeof(hMod),dwSize2) then begin
                // Get Full pathname:
                if lpfGetModuleFileNameEx(hProcess,hMod,szFileName,sizeof(szFileName)) = 0 then
                  szFileName[0] := #0;
              end;
              CloseHandle(hProcess);
//              WriteLn(ExtractFileName(StrPas(szFileName)));
              if Lowercase(ExtractFileName(StrPas(szFileName))) = Lowercase(Name) then begin
                hProcess := OpenProcess(PROCESS_ALL_ACCESS,True,lpdwPIDs[dwIndex]);
                if hProcess <> 0 then
                  WaitForSingleObject(HProcess,INFINITE);
                CloseHandle(hProcess);
                Result := lpdwPIDs[dwIndex];
                Break;
              end;
            end;
{
            if StrIComp(szFileName + (strlen(szFileName) - 9),'NTVDM.EXE') = 0 then begin
               // Enum the 16-bit stuff.
               lpfVDMEnumTaskWOWEx(lpdwPIDs[dwIndex],@Enum16,PChar(Name));
            end;
}
            Inc(dwIndex);
         end;

         HeapFree(GetProcessHeap(),0,lpdwPIDs);
         FreeLibrary(hInstLib2);
      // If Windows 95:
      end
      else if osver.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS then begin
        hInstLib := LoadLibraryA('Kernel32.DLL');
        if hInstLib = 0 then
          Exit;
         // Get procedure addresses.
         // We are linking to these functions of Kernel32
         // explicitly, because otherwise a module using
         // this code would fail to load under Windows NT,
         // which does not have the Toolhelp32
         // functions in the Kernel 32.
         lpfCreateToolhelp32Snapshot := GetProcAddress(hInstLib,'CreateToolhelp32Snapshot');
         lpfProcess32First := GetProcAddress(hInstLib,'Process32First');
         lpfProcess32Next := GetProcAddress(hInstLib,'Process32Next');
         if (Integer(@lpfProcess32Next)= 0) or (Integer(@lpfProcess32First)= 0) or (Integer(@lpfCreateToolhelp32Snapshot)= 0) then begin
           FreeLibrary( hInstLib ) ;
           Exit;
         end;

         // Get a handle to a Toolhelp snapshot of the systems
         // processes.
         hSnapShot := lpfCreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);
         if hSnapShot = INVALID_HANDLE_VALUE then begin
           FreeLibrary( hInstLib ) ;
           Exit;
         end;

         // Get the first process' information.
         procentry.dwSize := sizeof(PROCESSENTRY32) ;
         bFlag := lpfProcess32First(hSnapShot,procentry) ;

         // While there are processes, keep looping.
         while  bFlag do begin
//           WriteLn(ExtractFileName(StrPas(procentry.szExeFile)));
          if Lowercase(ExtractFileName(StrPas(procentry.szExeFile))) = Lowercase(Name) then begin
            hProcess := OpenProcess(PROCESS_ALL_ACCESS,True,procentry.th32ProcessID);
            if hProcess <> 0 then
              WaitForSingleObject(HProcess,INFINITE);
            CloseHandle(hProcess);
            Break;
          end;
          bFlag := lpfProcess32Next( hSnapShot, procentry );
         end;
      end
      else
        Exit;

      // Free the library.
      FreeLibrary( hInstLib ) ;
end;

procedure Launch(FStartDir,FFileName,FParameters: string);
var
  ShellInfo: TShellExecuteInfo;
  FExitCode: DWord;
  FHProcess: THandle;
  Handles: array[0..1] of THandle;
begin
  FExitCode := 0;

  FillChar(ShellInfo,SizeOf(TShellExecuteInfo),0);
  ShellInfo.cbSize := SizeOf(TShellExecuteInfo);
  ShellInfo.fMask := SEE_MASK_NOCLOSEPROCESS;
  ShellInfo.Wnd := HWnd_Desktop;
  ShellInfo.lpVerb := 'open';
  ShellInfo.lpFile := PChar(FFileName);
  ShellInfo.lpParameters := PChar(FParameters);
  ShellInfo.lpDirectory := PChar(FStartDir);
  ShellInfo.nShow := ShowWindowModes[smNormal];

  if ShellExecuteEx(@ShellInfo) then
    begin
      FHProcess := ShellInfo.hProcess;
      Handles[0] := FHProcess;
      case WaitForSingleObject(FHProcess,INFINITE) of
//        wait_Failed: CreateLaunchError(GetLastError);
        wait_Object_0: GetExitCodeProcess(FHProcess,FExitCode);
//        wait_Timeout: raise EProgramLauncherTimeout.Create(SProgramLaunchTimeOut);
      end;
    end
end;

function BytesToStr(B: array of char): string;
var
  i: integer;
begin
  Result := '';
  i := 0;
  while B[i] <> #0 do begin
    Result := Result + B[i];
    Inc(i);
  end;
end;

procedure WriteSetupFile(Name: string; Size: integer);
var
  Sz,p: integer;
  WStream: TFileStream;
  Buf: array[0..1023] of byte;
begin
  WStream := TFileStream.Create(TempPath + Name,fmCreate);
  try
    repeat
      if Size >= SizeOf(Buf) then
        Sz := SizeOf(Buf)
      else
        Sz := Size;
      Dec(Size,Sz);
      Stream.Read(Buf,Sz);
      WStream.Write(Buf,Sz);
    until (Size <= 0);
  finally
    WStream.Free;
  end;
end;

begin
  if GetTempPath(SizeOf(TempDir),TempDir) = 0 then
    TempPath := ''
  else
    TempPath := StrPas(TempDir);

  ExePath := ParamStr(0);
  Stream := TFileStream.Create(ExePath,fmOpenRead + fmShareDenyWrite);
  try
    Stream.Seek(-SizeOf(longword),soFromEnd);
    Stream.Read(ID,SizeOf(longword));
    if ID <> SETUPEXE_ID then begin
      WriteLn('File has no data. Press Enter to continue.');
      ReadLn;
      Exit;
    end;
    Stream.Seek(-SizeOf(longint) * 2,soFromEnd);
    Stream.Read(FileCount,SizeOf(longint));
    if (FileCount < 0) or (FileCount > 20000) then begin
      WriteLn('Bad filecount. Press Enter to continue.');
      ReadLn;
      Exit;
    end;
    SetLength(Files,FileCount);
    Stream.Seek(-(SizeOf(longint) * 2 + SizeOf(TFileData) * FileCount),soFromEnd);
    Stream.Read(Files[0],SizeOf(TFileData) * FileCount);
    Stream.Seek(-(SizeOf(longint) * 2 + SizeOf(TFileData) * FileCount),soFromEnd);
    for i := High(Files) downto 0 do begin
      Stream.Seek(-Files[i].Size,soFromCurrent);
      RunFile := BytesToStr(Files[i].Name);
      p := Pos(':',RunFile);
      if p > 0 then
        RunFile := Copy(RunFile,1,p - 1);
      WriteSetupFile(RunFile,Files[i].Size);
      Stream.Seek(-Files[i].Size,soFromCurrent);
    end;
    for i := 0 to High(Files) do begin
      if (Files[i].Flags and FD_FLAG_EXECUTE) = FD_FLAG_EXECUTE then begin
        RunFile := BytesToStr(Files[i].Name);
        p := Pos(':',RunFile);
        if p > 0 then begin
          WaitFile := Copy(RunFile,p + 1,1024);
          RunFile := Copy(RunFile,1,p - 1);
        end
        else
          WaitFile := '';
        Params := BytesToStr(Files[i].Params);
        WriteLn(TempPath + RunFile + ' ' + Params);
        Launch('',TempPath + RunFile,Params);
        if WaitFile <> '' then
          WaitProcessByName(WaitFile);
      end;
    end;
    for i := 0 to High(Files) do begin
      RunFile := BytesToStr(Files[i].Name);
      p := Pos(':',RunFile);
      if p > 0 then
        RunFile := Copy(RunFile,1,p - 1);
      DeleteFile(PChar(TempPath + RunFile));
    end
  finally
    Stream.Free;
  end;
end.